/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.ImageIcon;
class GameWindow extends JFrame {
	private Canvas cGame = new Canvas() {
		public void paint(Graphics g) {
			drawGame();
		}
	};
	private Canvas cLChooser = new Canvas() {
		public void paint(Graphics g) {
			drawLevelChooser();
		}
	};
	
	private JPanel pButtons = new JPanel();
	private JButton bClassic = new JButton("Classic");
	private JButton bFressen = new JButton("Fressen");
	private JButton bVielfrass = new JButton("Vielfrass");
	private JButton bVerwelken = new JButton("Verwelken");
	private JButton bBSnake = new JButton("Blind-Snake");
	private JButton bStats = new JButton("Statistik");
	private JButton bClose = new JButton("Beenden");
	
	private JPanel pControl = new JPanel();
	
	private JPanel pLevelC = new JPanel();
	
	private JLabel lHud = new JLabel("<HTML>Äpfel: 0/0<br>Äpfel bis neue: ---<br>Verbleibene Zeit: ---</HTML>");
	private StatWindow statWin = null;
	
	private GUIUpdater guiUpdater;
	private GameLoop gameLoop;
	private JSLevel level;
	private Player player;
	private int type;
	private int lev;
	private Timer t;
	
	private int size=500;
	private boolean hd;
	
	public GameWindow(Player p, boolean hd) {
		this.hd = hd;
		if (hd) size=1000;
		setTitle("Jippy Snake 7");
		setResizable(false);
		setIconImage( new ImageIcon("logo/logo_32.png").getImage() );
		
		player = p;
		setType(0);
		
		cGame.setPreferredSize(new Dimension(size,size));
		cLChooser.setPreferredSize(new Dimension(250,250));
		
		lHud.setVerticalAlignment(JLabel.TOP);
		pButtons.setLayout(new GridLayout(9,1));
		pButtons.add(bFressen);
		pButtons.add(bVielfrass);
		pButtons.add(bClassic);
		pButtons.add(bVerwelken);
		pButtons.add(bBSnake);
		pButtons.add(new JLabel(""));
		pButtons.add(bStats);
		pButtons.add(new JLabel(""));
		pButtons.add(bClose);
		
		pControl.setLayout(new BorderLayout());
		setLayout(new BorderLayout());
		add(cGame, BorderLayout.WEST);
		//add(lHud, BorderLayout.SOUTH);
		pLevelC.setLayout(new BorderLayout());
		pLevelC.add(new JLabel("Level wählen:"), BorderLayout.NORTH);
		pLevelC.add(cLChooser, BorderLayout.SOUTH);
		pControl.add(pLevelC, BorderLayout.NORTH);
		pControl.add(lHud, BorderLayout.CENTER);
		pControl.add(pButtons, BorderLayout.SOUTH);
		add(pControl, BorderLayout.EAST);
		if (hd) add(new JLabel(""), BorderLayout.SOUTH);
		
		if (hd) {
			setUndecorated(true);
			setExtendedState(Frame.MAXIMIZED_BOTH);
		}
		pack();
		if (hd) {
			setExtendedState(Frame.MAXIMIZED_BOTH);
			setAlwaysOnTop(true);
		}
		setVisible(true);
		
		loadLevel();
		
		cGame.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_UP)
					turn(0,-1);
				else if (e.getKeyCode() == KeyEvent.VK_DOWN)
					turn(0,1);
				else if (e.getKeyCode() == KeyEvent.VK_LEFT)
					turn(-1,0);
				else if (e.getKeyCode() == KeyEvent.VK_RIGHT)
					turn(1,0);
				else if (e.getKeyCode() == KeyEvent.VK_NUMPAD0)
					playPause();
			}
		});
		
		cLChooser.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				loadLevel((e.getX()/25) + 10*(e.getY()/25));
				setFocusToGame();
			}
		});
		
		bFressen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setType(1);
				loadLevel();
			}
		});
		bClassic.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setType(0);
				loadLevel();
			}
		});
		bVielfrass.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setType(2);
				loadLevel();
			}
		});
		bVerwelken.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setType(3);
				loadLevel();
			}
		});
		bBSnake.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setType(4);
				loadLevel();
			}
		});
		
		bStats.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				openStatWin();
			}
		});
		
		bClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
			
			public void windowGainedFocus(WindowEvent e) {
				setFocusToGame();
			}
		});
		
	}
	
	private void playPause() {
		gameLoop.setPaused(!gameLoop.getPaused());
	}
	
	private void setFocusToGame() {
		cGame.requestFocus();
	}
	private void openStatWin() {
		if (statWin == null) {
			statWin = new StatWindow(player);
		} else {
			if (statWin.isClosed()) {
				statWin.dispose();
				statWin = new StatWindow(player);
			}
		}
	}
	
	private void setType(int t) {
		if ((gameLoop != null) && gameLoop.getPaused()) return;
		type = t;
		
		if (type == 0)
			bClassic.setText("<html><font color=#ff0000>Classic</font></html>");	
		else
			bClassic.setText("<html><font color=#000000>Classic</font></html>");	
		
		if (type == 1)
			bFressen.setText("<html><font color=#ff0000>Fressen</font></html>");
		else
			bFressen.setText("<html><font color=#000000>Fressen</font></html>");
		
		if (type == 2)
			bVielfrass.setText("<html><font color=#ff0000>Vielfrass</font></html>");
		else
			bVielfrass.setText("<html><font color=#000000>Vielfrass</font></html>");
		
		if (type == 3)
			bVerwelken.setText("<html><font color=#ff0000>Verwelken</font></html>");
		else
			bVerwelken.setText("<html><font color=#000000>Verwelken</font></html>");
		
		if (type == 4)
			bBSnake.setText("<html><font color=#ff0000>Blind-Snake</font></html>");
		else
			bBSnake.setText("<html><font color=#000000>Blind-Snake</font></html>");
		
		lev = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[type] ; i++) {
			if (player.getLevelDone(type, i) == 1) {
				lev = i;
				break;
			}
		}
	}
	private void loadLevel(int num) {
		if ((gameLoop != null) && gameLoop.getPaused()) return;
		if (num >= Globals.NUM_LEVELS[type]) return;
		if (player.getLevelDone(type, num) == 0) return;
		level = JSLevel.loadLevel("res/levels/level"+Integer.toString(type)+"_"+Integer.toString(num)+".js7l");
		Snake s = new Snake(Coord.getZeroCoord());
		s.place(level);
		if (t != null) t.cancel();
		
		cGame.requestFocus();
		guiUpdater = new GUIUpdater(hd, cGame, cLChooser, type, lHud, level, s, player);
		gameLoop = new GameLoop(level, s, guiUpdater, player);
		guiUpdater.drawLevel();
		guiUpdater.drawLevelChooser();
		
		t = new Timer();
		t.schedule(gameLoop, 0, 250);
	}
	
	private void loadLevel() {
		loadLevel(lev);
	}
	
	private void turn(int dx, int dy) {
		if ((gameLoop != null) && gameLoop.getPaused()) return;
		gameLoop.setDir(new Coord(dx,dy,0));
	}
	
	private void drawGame() {
		if (guiUpdater != null) guiUpdater.showGame();
	}
	
	private void drawLevelChooser() {
		if (guiUpdater != null) guiUpdater.showLevelChooser();
	}

}